package struclust;

import graph.Graph;

import java.util.List;

import struclust.eval.EvalResult;

/**
 * Just an empty hull, that does nothing (for mocking and testing purpose)
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 */
public class FakeSC<NL, EL, G extends Graph<NL, EL>> implements StructuralClustering<NL, EL, G> {

    @Override
    public void addAsMetadata(EvalResult result) {
        result.addMetadata("clusterer", this.getClass().getName());
    }

    @Override
    public List<Cluster<NL, EL, G>> calc() {
        return null;
    }

    @Override
    public StructuralClusteringConf<NL, EL, G> getConf() {
        return (EvalResult result) -> {};
    }

    @Override
    public void calcFingerprints() {}

    @Override
    public void updateReps(List<Cluster<NL, EL, G>> clusters) {}

}
