package struclust.eval.modules;

import java.util.Collection;
import java.util.Collections;

import struclust.eval.EvalException;
import struclust.eval.EvalResult;

/**
 * Evaluation Module that simply outputs pre-defined key value pairs.
 * 
 * @author Till Schäfer
 *
 */
public class PredefinedResultEM extends AbstractEM<Object> {

    private Collection<EvalResult> results;

    /**
     * Constructor
     * 
     * @param measurement
     *            the measurement title
     * @param key
     *            the key of the result
     * @param value
     *            the values of the result
     */
    public PredefinedResultEM(String measurement, String key, String value) {
        EvalResult retVal = new EvalResult(measurement);
        retVal.addResult(key, value);
        results = Collections.singleton(retVal);
    }

    /**
     * Constructor
     * 
     * @param results
     *            A {@link Collection} of {@link EvalResult}s
     */
    public PredefinedResultEM(Collection<EvalResult> results) {
        this.results = results;
    }

    @Override
    public Collection<EvalResult> run() throws EvalException {
        return results;
    }

    @Override
    public Collection<EvalResult> run(Object testData) throws EvalException {
        throw new UnsupportedOperationException("PredefinedResultEM cannot run a test with precomputed test data");
    }

    @Override
    public boolean canUsePrecomputedTestData() {
        return false;
    }

}
