package struclust.eval.modules.clustering;

import graph.Graph;

import java.util.Collection;
import java.util.Collections;
import java.util.List;

import struclust.Cluster;
import struclust.StructuralClustering;
import struclust.eval.EvalException;
import struclust.eval.EvalResult;

/**
 * Write out the number of clusters
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 * @param <EL>
 * @param <G>
 */
public class NumClustersEM<NL, EL, G extends Graph<NL, EL>> extends PrecompClustEM<NL, EL, G> {

    /**
     * Constructor
     * 
     * @param clust
     */
    public NumClustersEM(StructuralClustering<NL, EL, G> clust) {
        super(clust);
    }

    @Override
    protected Collection<EvalResult> runInternal(List<Cluster<NL, EL, G>> clustering) throws EvalException {
        EvalResult result = new EvalResult("NumClusters");
        result.addMetadata(clust.getConf());
        result.addResult("numClusters", testData.size());
        return Collections.singleton(result);
    }

}
