package graph;

/**
 * Factory for {@link DefaultGraph}s
 * 
 * @author Till Schäfer
 * 
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 */
public class DefaultGraphFactory<NL, EL> implements GraphFactory<NL, EL, DefaultGraph<NL, EL>> {

    @Override
    public DefaultGraph<NL, EL> create() {
        return new DefaultGraph<>();
    }

    @Override
    public DefaultGraph<NL, EL> clone(DefaultGraph<NL, EL> source) {
        return new DefaultGraph<>(source);
    }

}
