package hsahn.comparison.distance;

import hsahn.graph.LGraph;
import hsahn.mcs.MCSAlgorithm;

public abstract class MCSDistance implements Distance<LGraph<String,String>> {
	
	MCSAlgorithm algo;
	
	public MCSDistance(MCSAlgorithm algo) {
		this.algo = algo;
	}
	
	public MCSDistance() {
		this(new MCSAlgorithm.MaximumClique());
	}

	@Override
	public double compute(LGraph<String,String> lg1, LGraph<String,String> lg2) {
//	    Date before = new Date();
		int mcs = algo.computeMCS(lg1, lg2);
		int lg1VertexCount = lg1.getGraph().getVertexCount();
		int lg2VertexCount = lg2.getGraph().getVertexCount();
		double retVal = compute(mcs, lg1VertexCount, lg2VertexCount);
//		Date after = new Date();
//		System.out.println("Single Calculation Time: " + (after.getTime() - before.getTime()));
        return retVal;
	}
	
	protected abstract double compute(int mcs, int v1, int v2);

}
