package hsahn.mcs;

import hsahn.graph.Graph;
import hsahn.graph.Graph.Vertex;

import java.util.LinkedList;

public class KCliqueFinderReference {

	private Graph graph;
	private int k;
	private int states;
	private int kCliqueCount;
	
	public KCliqueFinderReference(Graph graph, int k) {
		this.graph = graph;
		this.k = k;
	}
	
	
	public int computeKCliques() {
		states = 0;
		kCliqueCount = 0;
		
		LinkedList<Vertex> cand = new LinkedList<Vertex>();
		for (Vertex v : graph.vertices())
			cand.add(v);
		
		maxClique(0, cand);
		
		return kCliqueCount;
	}
	
	
	private void maxClique(int size, LinkedList<Vertex> cand) {
		states++;

		while (!cand.isEmpty()) {

			Vertex v = cand.pollLast();
			
			//kCliqueCount++;
			kCliqueCount += size+1;
			if (size+1 == k) {
				continue;
			}
			
			LinkedList<Vertex> newCand = new LinkedList<Vertex>();
			for (Vertex w : v.neighbors()) {
				if (cand.contains(w))
					newCand.add(w);
			}
			
			maxClique(size+1, newCand);
		}
	}
	
}
