package hsahn.mcs;

import hsahn.graph.Graph;
import hsahn.graph.LGraph;

public interface MCSAlgorithm {
	
	public int computeMCS(LGraph<?,?> lg1, LGraph<?, ?> lg2);
	
	
	public class MaximumClique implements MCSAlgorithm {

		@Override
		public int computeMCS(LGraph<?, ?> lg1, LGraph<?, ?> lg2) {
			Graph pg = new AssociationGraph(lg1, lg2);
			MaximumCliqueFinder mcf = new MaximumCliqueFinder(pg);
			return mcf.computeMaxSize();
		}
		
	}

}
