package hsahn.mcs;

import hsahn.datastructure.Pair;
import hsahn.graph.Graph;
import hsahn.graph.Graph.Vertex;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.Set;


public class TreeSearch {
	
	// TODO this is not thread-safe: use class instead of static methods
	private static int globalMax;
	
	// TODO maximum or maximal?
	public static Set<LinkedList<Pair<Vertex,Vertex>>> findMCS(Graph g1, Graph g2) {
		Set<LinkedList<Pair<Vertex,Vertex>>> result = new HashSet<LinkedList<Pair<Vertex,Vertex>>>();
		
		PartialMapping pm = new PartialMapping(g1, g2);
		
		globalMax = 0;
		recursion(pm, 0, result);
		
		return result;
	}
	
	private static void recursion(PartialMapping pm, int g1VertexIdx, Set<LinkedList<Pair<Vertex,Vertex>>> result) {
		
		if (pm.getSize() > globalMax) {
			globalMax = pm.getSize();
			result.clear();
		}
		if (pm.getSize() == globalMax) {
			result.add(pm.getMapping());
		}
		
		if (g1VertexIdx >= pm.g1.getVertexCount())
			return;
		Vertex u = pm.g1.getVertex(g1VertexIdx);
		
		for (Vertex v : pm.g2.vertices()) {
			if (pm.isFeasiblePair(u, v, u.edges(), v.edges())) {
				pm.extend(u, v);
				recursion(pm, g1VertexIdx+1, result);
				pm.remove(u, v);
			}
		}
		
		// don't map current vertex
		recursion(pm, g1VertexIdx+1, result);
	}

}
