package index.util;

import java.io.Serializable;

public class LabelCounter implements Serializable {
	
	private static final long serialVersionUID = 1;
	
	int size;
	short[] counter;
	
	public LabelCounter(int size) {
		this.size = size;
		counter = new short[size];
	}
	
	public void add(Object o) {
		int position = Hashing.hash(o, size);
		counter[position]++;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (short s : counter) {
			sb.append(s);
			sb.append(' ');
		}
		return sb.toString();
	}
	
	public boolean contains(LabelCounter lc) {
		if (getSize() != lc.getSize()) {
			throw new IllegalArgumentException("Uncomparable Counter");
		}
		
		for (int i=0; i<size; i++) {
			if (counter[i]<lc.counter[i])
				return false;
		}
		return true;
	}
	
	public int getSize() {
		return size;
	}

}
