package match;

import graph.Node;

/**
 * A pair of labels for an automorphism "<" condition
 * @author Markus Kloss
 * 
 * <NL> The node label
 */
public class AutoCondition<NL, EL> {

    protected Node<NL, EL> firstNode;
    protected Node<NL, EL> secondNode;
    
    /**
     * Constructor
     * @param firstNode The lower {@link Node} of the condition
     * @param secondNode The upper {@link Node} of the condition
     */
    public AutoCondition(Node<NL, EL> firstNode, Node<NL, EL> secondNode)
    {
        this.firstNode = firstNode;
        this.secondNode = secondNode;
    }
    
    /**
     * Returns the first node
     * @return The lower node
     */
    public Node<NL, EL> getFirstNode()
    {
        return this.firstNode;
    }
    
    /**
     * Returns the second node
     * @return The upper node
     */
    public Node<NL, EL> getSecondNode()
    {
        return this.secondNode;
    }
    
    /**
     * toString() function
     * 
     * @override
     */
    public String toString()
    {
        return "("+this.firstNode.toString()+"< "+this.secondNode.toString()+")";
    }
}
