package struclust.competingalgorithms.opensubspace;

import graph.Graph;
import hsahn.datastructure.FeatureVector;

import java.util.function.Function;

import struclust.Describable;

/**
 * Transforms a {@link Graph} to an arbitrary {@link FeatureVector}.
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 */
public interface ToFeatureVectorFunction<NL, EL, G extends Graph<NL, EL>> extends Function<G, FeatureVector<? extends Object>>,
        Describable {
}
