package struclust.competingalgorithms.trickl;

import graph.Graph;
import hsahn.comparison.kernel.ExplicitMappingKernel;
import hsahn.datastructure.FeatureVector;
import hsahn.graph.LGraph;
import struclust.StructuralClusteringConf;
import struclust.eval.EvalResult;

/**
 * Configuration for {@link WrappedKernelKMeans} clustering.
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 * @param <T>
 *            the {@link FeatureVector} type
 */
public class ExplicitKernelKMeansConf<NL, EL, G extends Graph<NL, EL>, T>
        implements StructuralClusteringConf<NL, EL, G> {

    /**
     * the kernel function
     */
    public ExplicitMappingKernel<LGraph<NL, EL>, ? extends FeatureVector<T>> kernel;

    /**
     * the number of clusters
     */
    public int numCluster;

    @Override
    public void addAsMetadata(EvalResult result) {
        result.addMetadata("kernel", kernel.toString());
    }

}
