package struclust.competingalgorithms.trickl;

import graph.Graph;
import hsahn.comparison.kernel.Kernel;
import hsahn.graph.LGraph;
import struclust.StructuralClusteringConf;
import struclust.eval.EvalResult;

/**
 * Configuration for {@link WrappedKernelKMeans} clustering.
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 */
public class KernelKMeansConf<NL, EL, G extends Graph<NL, EL>> implements StructuralClusteringConf<NL, EL, G> {

    /**
     * the kernel function
     */
    public Kernel<LGraph<NL, EL>> kernel;
    
    /**
     * the number of clusters
     */
    public int numCluster;
    
    @Override
    public void addAsMetadata(EvalResult result) {
        result.addMetadata("kernel", kernel.toString());
    }

}
