package struclust.distributions;

import cern.jet.random.AbstractDistribution;

/**
 * This is the dirac (or degenerate) distribution. It will always return the
 * same value.
 * 
 * @author Till Schäfer
 *
 */
public class Dirac extends AbstractDistribution {
    private static final long serialVersionUID = 8852571592131872779L;
    private double value;

    /**
     * Constructor
     * 
     * @param value
     *            the value which is returned by this distribution
     */
    public Dirac(double value) {
        this.value = value;
    }

    @Override
    public double nextDouble() {
        return value;
    }

    @Override
    public Dirac clone() {
        return new Dirac(value);
    }

    @Override
    public String toString() {
        return this.getClass().getName() + "(" + value + ")";
    }

}
