package struclust.graph.generators;

import graph.Graph;

import java.util.List;

import struclust.Describable;

/**
 * Interface for {@link Graph} generators.
 * 
 * @author Till Schäfer
 *
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 */
public interface RandomGraphGenerator<NL, EL, G extends Graph<NL, EL>> extends Describable{
    /**
     * Generate some {@link Graph}s
     * 
     * @param num
     *            the number of graphs to generate
     * @return the generated graphs
     */
    List<G> createGraphs(int num);
}
