package struclust.mcs;

import struclust.Describable;

/**
 * Interface for different kinds of maximum common subgraph algorithms
 * 
 * @author Till Schäfer
 */
public interface McsAlgorithm extends Describable {
    /**
     * the value is true iff the algorithm computes maximum connected common
     * subgraphs (MCCS)
     * 
     * @return true iff connected
     */
    public boolean isConnected();

    /**
     * the value is true iff the algorithm computes maximum common induced
     * subgraphs (MCIS)
     * 
     * @return true iff induced
     */
    public boolean isInduced();
}
