package struclust.mcs;

import graph.Graph;

import java.util.List;

/**
 * Algorithm, that computes all maximum common subgraphs (MCS) of two
 * {@link Graph}s.
 * 
 * @author Till Schäfer
 * 
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 *
 */
public interface McsEnumAlgorithm<NL, EL, G extends Graph<NL, EL>> extends McsAlgorithm {
    /**
     * Enumerates all maximum common subgraphs (MCS).
     * 
     * @param graph1
     *            the first {@link Graph}
     * @param graph2
     *            the second {@link Graph}
     * @return all MCS
     */
    public List<G> calc(G graph1, G graph2);

}
