package struclust.repselection;

import graph.Graph;

import java.util.ArrayList;
import java.util.List;

import struclust.Cluster;
import struclust.graph.GraphContainer;

/**
 * Always selects the newer representatives as cluster representatives
 * 
 * @author Till Schäfer
 * 
 * @param <NL>
 *            the node label type
 * @param <EL>
 *            the edge label type
 * @param <G>
 *            the graph type
 */
public class NewRSS<NL, EL, G extends Graph<NL, EL>> implements RepSelectionStrategy<NL, EL, G> {

    @Override
    public ArrayList<GraphContainer<NL, EL, G>> select(Cluster<NL, EL, G> cluster,
            ArrayList<GraphContainer<NL, EL, G>> newReps, List<Cluster<NL, EL, G>> clustering) {
        return newReps;
    }

    @Override
    public String getDescription() {
        return "NewRSS";
    }

}
