package struclust.tools.stripmembers;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.commons.lang3.StringUtils;

import com.beust.jcommander.JCommander;

/**
 * Strips the cluster members from a GML-Clustering-File
 * 
 * @author Till Schäfer
 */
public class StripMembers {

    /**
     * Main-Method
     * 
     * @param args
     *            see {@link Parameters} for further information
     */
    public static void main(String[] args) {
        Parameters param = new Parameters();
        new JCommander(param, args);

        try (FileReader input = new FileReader(param.inFile);
                BufferedReader reader = new BufferedReader(input);
                FileWriter output = new FileWriter(param.outFile);
                BufferedWriter writer = new BufferedWriter(output);) {
            boolean memberLine = false;
            int open = 0;
            for (String line = reader.readLine(); line != null; line = reader.readLine()) {
                if (memberLine) {
                    open += StringUtils.countMatches(line, "[");
                    open -= StringUtils.countMatches(line, "]");
                    if (open < 0) {
                        memberLine = false;
                        writer.write(line + System.getProperty("line.separator"));
                    }
                } else {
                    if (line.contains("members")) {
                        memberLine = true;
                        open = 0;
                    }
                    writer.write(line + System.getProperty("line.separator"));
                }
            }
        } catch (IOException e) {
            System.out.println("Could not read file");
            e.printStackTrace();
        }
    }

}
