package struclust.util;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

/**
 * Class for convenient methods regarding {@link Collection}s
 * 
 * @author Till Schäfer
 */
public class Collections {
    /**
     * Converts all elements into a LinkedList.
     * 
     * @param elements
     *            the elements of the {@link LinkedList}
     * @return the {@link LinkedList} containing all elements
     */
    @SafeVarargs
    public static <T> List<T> asLinkedList(T... elements) {
        List<T> retVal = new LinkedList<>();
        for (T t : elements) {
            retVal.add(t);
        }

        return retVal;
    }
}
