package tools.io;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map.Entry;

public class LabelConverter {
	
	private static LabelConverter instance = new LabelConverter();
	
	private HashMap<Object, Integer> convMap;
	private int lastNumber;
	
	private LabelConverter() {
		convMap = new HashMap<Object, Integer>();
		convMap.put("-", 2);                                                                                                                           
		convMap.put("=", 3);                                                                                                                           
		convMap.put("#", 4);                                                                                                                           
		convMap.put("C", 5);                                                                                                                           
		convMap.put("H", 6);                                                                                                                           
		convMap.put("N", 7);                                                                                                                           
		convMap.put("O", 8);                                                                                                                           
		convMap.put("Cl", 9);                                                                                                                          
		convMap.put("F", 10);                                                                                                                          
		convMap.put("S", 11);                                                                                                                          
		convMap.put("Br", 12);                                                                                                                         
		convMap.put("I", 13);                                                                                                                          
		convMap.put("Cu", 14);                                                                                                                         
		convMap.put("P", 15);                                                                                                                          
		convMap.put("Zn", 16);                                                                                                                         
		convMap.put("B", 17);                                                                                                                          
		convMap.put("Co", 18);                                                                                                                         
		convMap.put("Mn", 19);                                                                                                                         
		convMap.put("As", 20);                                                                                                                         
		convMap.put("Al", 21);                                                                                                                         
		convMap.put("Ni", 22);                                                                                                                         
		convMap.put("Se", 23);                                                                                                                         
		convMap.put("Si", 24);                                                                                                                         
		convMap.put("V", 25);                                                                                                                          
		convMap.put("Zr", 26);                                                                                                                         
		convMap.put("Sn", 27);                                                                                                                         
		convMap.put("Li", 28);                                                                                                                         
		convMap.put("Sb", 29);                                                                                                                         
		convMap.put("Fe", 30);                                                                                                                         
		convMap.put("Bi", 31);                                                                                                                         
		convMap.put("Pd", 32);                                                                                                                         
		convMap.put("Hg", 33);                                                                                                                         
		convMap.put("Na", 34);
		convMap.put("Ca", 35);
		convMap.put("Ti", 36);
		convMap.put("Ho", 37);
		convMap.put("Ge", 38);
		convMap.put("Pt", 39);
		convMap.put("Ru", 40);
		convMap.put("Rh", 41);
		convMap.put("Cr", 42);
		convMap.put("Ga", 43);
		convMap.put("K", 44);
		convMap.put("Ag", 45);
		convMap.put("Au", 46);
		convMap.put("Tb", 47);
		convMap.put("Ir", 48);
		convMap.put("Te", 49);
		convMap.put("Mg", 50);
		convMap.put("Pb", 51);
		convMap.put("W", 52);
		convMap.put("Cs", 53);
		convMap.put("Mo", 54);
		convMap.put("Re", 55);
		convMap.put("Cd", 56);
		convMap.put("Os", 57);
		convMap.put("Pr", 58);
		convMap.put("Nd", 59);
		convMap.put("Sm", 60);
		convMap.put("Gd", 61);
		convMap.put("Yb", 62);
		convMap.put("Er", 63);
		convMap.put("U", 64);
		convMap.put("Tl", 65);
		convMap.put("Nb", 66);
		convMap.put("Ac", 67);


		lastNumber = 67;
	}
	
	private static HashMap<Object, Integer> o2i = new HashMap<Object, Integer>();
	private static HashMap<Integer, Object> i2o = new HashMap<Integer, Object>();
	
//	public static int calcInt(Object o) {
//		Integer label = null;
//		
//		if (o instanceof Integer) {
//			label = (Integer)o;
//		} else if (o instanceof String) {
//			try {
//				label = Integer.valueOf((String)o);
//			} catch (NumberFormatException e) {
//				// ignore
//			}
//		}
//
//		if (label == null) {
//			label = o.hashCode();
//		}
//		
//		// assure label >=2
//		if (label < 2) {
//			label = 32766-label;
//		}
//		
//		Integer c = o2i.get(o);
//		if (c != null) {
//			if (!label.equals(c)) {
//				throw new IllegalArgumentException("Internal error: "+label+"\t"+c);
//			}
//		}
//		
//		o2i.put(o, label);
//		i2o.put(label, o);
//		
//		return label; 
//	}
	
	public static int calcInt(Object o) {
		Integer label = o2i.get(o);
		
		if (label == null) {
			label = ++instance.lastNumber;
			instance.convMap.put(o, label);
		}
		
		return label; 
	}
	
//	public static Object intToLabel(int i) {
//		Object o = i2o.get(i);
//		if (o == null) throw new IllegalArgumentException("Label unkonown");
//		return o;
//	}
	
	public static int labelToInt(Object o) {
		Integer label = null;
		
		if (o instanceof Integer) {
			label = (Integer)o;
		} else if (o instanceof String) {
			try {
				label = Integer.valueOf((String)o);
			} catch (NumberFormatException e) {
				// ignore
			}
		}
		
		if (label != null)
			return label;
		
		Integer i = instance.convMap.get(o);
		//if (i == null) throw new IllegalArgumentException("Label unkonown: "+o);
		if (i == null) {
			i = calcInt(o);
		}
		return i;
	}
	
	public static void printMap() {
		HashMap<Integer, Object> inverseConvMap = new HashMap<Integer, Object>();
		for (Entry<Object, Integer> e : instance.convMap.entrySet()) {
			inverseConvMap.put(e.getValue(), e.getKey());
		}
		ArrayList<Integer> ints = new ArrayList<Integer>(inverseConvMap.keySet());
		Collections.sort(ints);
		for (Integer i : ints) {
			System.out.println(inverseConvMap.get(i)+"\t"+i);
//			System.out.println("convMap.put(\""+inverseConvMap.get(i)+"\", "+i+");");	
		}
	}

}
