package struclust.datastructures;

import java.util.ArrayList;

/**
 * Test Class for {@link RandomQueue}
 * 
 * @author Till Schäfer
 */
public class RandomQueueTest {
    /**
     * Simple test that ensures, that the ordering is randomized. Says nothing
     * about the quality of the randomization. Has a very low probability of
     * throwing an error while there is no error.
     */
    @org.junit.Test
    public void orderingTest() {
        ArrayList<Integer> input = new ArrayList<>();
        int numbers = 200;
        for (int i = 0; i < numbers; i++) {
            input.add(i);
        }
        RandomQueue<Integer> rq = new RandomQueue<>(input);

        for (int i = 0; i < numbers; i++) {
            if (rq.poll() != i) {
                return;
            }
        }

        throw new AssertionError("Queue Ordering is equal to input");
    }
}
